local CompactUnitFrame_UpdateDispellableDebuffs_ORIG = CompactUnitFrame_UpdateDispellableDebuffs

local LSM = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SimpleDispel")

SimpleDispel = CreateFrame('frame')
local SimpleDispel = SimpleDispel

SimpleDispel:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
SimpleDispel:RegisterEvent("ADDON_LOADED")


local defaults = {
	profile = {
		font = {
			name = "Friz Quadrata TT",
			size = 15,
			outline = "OUTLINE"
		},
		colors = {
			magic   = DebuffTypeColor["Magic"],
			curse   = DebuffTypeColor["Curse"],
			disease = DebuffTypeColor["Disease"],
			poison  = DebuffTypeColor["Poison"]
		}
	}
}
SimpleDispel.db = LibStub("AceDB-3.0"):New("SimpleDispelDB", defaults)

function SimpleDispel:ADDON_LOADED(event, addon)
	if addon == "SimpleDispel" then

		self:UnregisterEvent("ADDON_LOADED")
		self.ADDON_LOADED = nil

		if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
    end
end

SimpleDispel.hookedFrames = {}
function SimpleDispel:PLAYER_LOGIN(event)
	SLASH_SimpleDispel1 = "/simpledispel";
	SlashCmdList["SimpleDispel"] = function()
        self:ShowOptions()
    end
end

local dispelCastName
local playerClass = select(2, UnitClass("player"))
if playerClass == "DRUID" then 
	dispelCastName = GetSpellInfo(2782) -- Remove Corruption
	
elseif playerClass == "MAGE" then 
	dispelCastName = GetSpellInfo(475) -- Remove Curse
	
elseif playerClass == "PALADIN" then 
	dispelCastName = GetSpellInfo(4987) -- Cleanse
	
elseif playerClass == "PRIEST" then 
	dispelCastName = GetSpellInfo(527) -- Purify
	
elseif playerClass == "SHAMAN" then 
	dispelCastName = GetSpellInfo(51886) -- Cleanse Spirit
	
elseif playerClass == "MONK" then 
	dispelCastName = GetSpellInfo(115450) -- Detox
end

function SimpleDispel:hookFrame(frame)
	tinsert(self.hookedFrames, frame)
	
	frame.dispelText = frame:CreateFontString(frame:GetName().."DispelText", "OVERLAY")
	frame.dispelText:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, 5)
	frame.dispelText:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 0, 5)
	frame.dispelText:SetFont(LSM:Fetch("font", self.db.profile.font.name), self.db.profile.font.size, self.db.profile.font.outline)
	frame.dispelText:SetText("")
	frame.dispelText:Hide()

	frame:SetAttribute("alt-type1", "spell");
	frame:SetAttribute("spell", dispelCastName);
end

function SimpleDispel:UpdateConfig(option)
	local c = self.db.profile.font.color
	for _, frame in pairs(self.hookedFrames) do
		frame.dispelText:SetFont(LSM:Fetch("font", self.db.profile.font.name), self.db.profile.font.size, self.db.profile.font.outline)
		
		if option == "colors" or option == "testDebuff" then
			CompactUnitFrame_UpdateDispellableDebuffs(frame)
		end
	end
end

function CompactUnitFrame_UpdateDispellableDebuffs(frame)
	if frame.dispelText == nil then
		SimpleDispel:hookFrame(frame)
	end

	CompactUnitFrame_UpdateDispellableDebuffs_ORIG(frame)
		
	if(frame.hasDispelMagic) then
		local c = SimpleDispel.db.profile.colors.magic
		frame.dispelText:SetTextColor(c.r, c.g, c.b)
		frame.dispelText:SetText(L["DEBUFF_MAGIC"]);
		frame.dispelText:Show();
	
	elseif(frame.hasDispelCurse) then
		local c = SimpleDispel.db.profile.colors.curse
		frame.dispelText:SetTextColor(c.r, c.g, c.b)
		frame.dispelText:SetText(L["DEBUFF_CURSE"]);
		frame.dispelText:Show();
	
	elseif(frame.hasDispelDisease) then
		local c = SimpleDispel.db.profile.colors.disease
		frame.dispelText:SetTextColor(c.r, c.g, c.b)
		frame.dispelText:SetText(L["DEBUFF_DISEASE"]);
		frame.dispelText:Show();
	
	elseif(frame.hasDispelPoison) then
		local c = SimpleDispel.db.profile.colors.poison
		frame.dispelText:SetTextColor(c.r, c.g, c.b)
		frame.dispelText:SetText(L["DEBUFF_POISON"]);
		frame.dispelText:Show();
		
	elseif(SimpleDispel.db.profile.testDebuff) then
		frame.dispelText:SetTextColor(1, 1, 1)
		frame.dispelText:SetText(L["DEBUFF_DUMMY"]);
		frame.dispelText:Show();
		
	else
		frame.dispelText:SetText("");
		frame.dispelText:Hide();
	end
end
