local SimpleDispel = SimpleDispel
local API = LibStub("LibAceConfigAPI")
local LSM = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SimpleDispel")

local options = {
    type = "group",
    get = function( k )
                return ""
          end,
    set = function( k, v ) end,
    args = { },
}

local opt_text_outline = {
    ["none"]         = L["OPT_TEXT_OUTLINE_NONE"],
    ["OUTLINE"]      = L["OPT_TEXT_OUTLINE_THIN"],
    ["THICKOUTLINE"] = L["OPT_TEXT_OUTLINE_THICK"],
}

function SimpleDispel:ShowOptions()
    if not self.loaded then self:Load() end
    --LibStub("AceConfigDialog-3.0"):SetDefaultSize("SimpleDispel", 635, 490)
    LibStub("AceConfigDialog-3.0"):Open("SimpleDispel")
end

local buildGetter, buildSetter
function SimpleDispel:Load()
    self.loaded = true
	self.options = options
	
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("SimpleDispel", options)
	
	local opt = self.options.args
	
	opt.debug = API:createToggle(L["SHOW_FAKE"], "", "testDebuff")
	
	opt.font = API:createGroup(L["GROUP_FONT"], "")
	opt.font.args.fontName = API:createFontSelect(L["SELECT_FONT"], "", "name", LSM:HashTable("font"))
	opt.font.args.outline = API:createSelect(L["FONT_OUTLINE"], "", "outline", opt_text_outline)
	opt.font.args.fontSize = API:createRange(L["RANGE_FONT_SIZE"], "", "size", {5, 30, 1})
	
	opt.colors = API:createGroup(L["GROUP_COLOR"], "")
	opt.colors.args.poison = API:createColor(L["COLOR_POISON"], "", "poison", false)
	opt.colors.args.magic = API:createColor(L["COLOR_MAGIC"], "", "magic", false)
	opt.colors.args.disease = API:createColor(L["COLOR_DISEASE"], "", "disease", false)
	opt.colors.args.curse = API:createColor(L["COLOR_CURSE"], "", "curse", false)

	opt.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	local db = self.db.profile
	
	local function getColor(key)
		local c = db.colors[key.arg]
		return c.r, c.g, c.b
	end
    local function setColor(key, r, g, b)
		local c = db.colors[key.arg]
		c.r = r
		c.g = g
		c.b = b
		SimpleDispel:UpdateConfig("colors")
	end   
	
    API:injectSetGet(self.options, buildSetter(db), buildGetter(db)) 
    API:injectSetGet(opt.font, buildSetter(db.font), buildGetter(db.font)) 
    API:injectSetGet(opt.colors, setColor, getColor) 
end

function buildGetter(db)
	return function(key)
		if key.type == "input" then
			return tostring(db[key.arg])
		end
		return db[key.arg]
	end
end

function buildSetter(db)
	return function (key, value)
		if key.type == "input" then
			if not (tonumber(value) == nil) then
				value = tonumber(value)
			end
		end
		db[key.arg] = value
		SimpleDispel:UpdateConfig(key.arg)
	end
end